# -*- coding: utf-8 -*-

#librairies
import streamlit as st
import pandas
import dill
import numpy

#insérer un titre
st.title("Clustering - Déploiement")

#mise en cache du chargement du modèle
#pour éviter les rappels répétés
@st.cache_resource
def chargement_modele():
    #ouvrir le fichier en lecture binaire
    f = open("workflow.sav","rb")
    try:
        modele = dill.load(f)#chargement
    finally:
        f.close()#fermeture du fichier dans tous les cas
    return modele
        

#chargement du Pipeline
wkf = chargement_modele()

#organisation en trois colonnes
#de l'espace d'affichage
col1,col2,col3 = st.columns([2,1,5])

#text_input alignés sur la première colonne
SepLen = col1.text_input("Sepal length (4.3 -- 7.9) :", "5")
SepWidth = col1.text_input("Sepal width (2.0 -- 4.4) :", "3")
PetLen = col1.text_input("Petal length (1.0 -- 6.9) :", "4")
PetWidth = col1.text_input("Petal width (0.1 -- 2.5) :", "1")

#bouton "Calculer"
col1.button("Calculer")

#fonction pour transtypage de la saisie de l'utilisateur
#avec contrôle : valeur pas valide = numpy.NAN (cf. Simple Imputer)
def try_parse(str_value):
    try:
        value = float(str_value)
    except Exception:
        value = numpy.NAN
    #renvoyer le résultat
    return value

#conversion de la saisie en dictionnaire
the_value = {'Sepal_Length':try_parse(SepLen),'Sepal_Width':try_parse(SepWidth),
             'Petal_Length':try_parse(PetLen),'Petal_Width':try_parse(PetWidth)}

#puis en data frame
df = pandas.DataFrame([the_value])

#cluster attribué - affichage
with col3:
    st.write("Caracterisation des groupes :")
    st.image("radar.png")
    st.write("Cluster attribué : ",wkf.predict(df)[0])
    st.write("Distance aux clusters : ",pandas.DataFrame([wkf.transform(df)[0]],index=['Dist.'],columns=['0','1','2']))
